History
========

## 3.14.3

- [core] Fix ‘end of file reached’ error when oracle restarted during run
- [ora_autotask] Fix ORA-00972: identifier is too long

## 3.14.2

- [ora_init_param] Fix missing values with long names when using daemon
- [daemon] Add support for restarting after detecting disconnect from Oracle

## 3.14.1

- [release] cleaup content of package

## 3.14.0

- [ora_database] Fix removing stopped database & daemons running
- [ora_database] Acquire oracle_base from db parameter in on_destroy and fix database_properties bug
- [ora_init_param] Fix error when nil value found in database
- [ora_database] Make daemonized the default
- [ora_database] Change shell variable to template variable
- [core] Fix default SID detection

## 3.13.0

- [release] Add support for puppet 7 in metadata
- [ora_tablespace] Workaround listagg length limitation
- [tasks] Add tasks to export/backup/import/restore a database

## 3.12.3

- [ora_database] Handle OMF in ASM and FS in the same way

## 3.12.2

- [plans/extract_as_node] Make passwords mandatory

## 3.12.1

- [plans/extract_as_node] Fix password handling

## 3.12.0

- [ora_tablespace] Fix undefined method `downcase' for nil:NilClass for when not using OMF
- [extract_as_node] Initial implementation
- [ora_tablespace] Fix logging property on temp and undo tablespaces
- [ora_database] Change some parameters into readonly properties
- [ora_user] Fix SQL error when default roles is empty array
- [grants] Issue warning when using container on non container database
- [extract] Initial task and plan implementation to extract ALL oracle configuration
- [ora_database] Don’t show file_name in logfile_group when omf enabled
- [ora_tablespace] Don’t allo puppet resource to see data file name when omf enabled
- [ora_autotask] Add confinement

## 3.11.4

- [ora_object_grant/ora_tablespace] Apply fix to index 12 version of script too
- [ora_object_grant] Fix when used with max_string_size to "EXTENTED"
- [ora_tablespace] Fix when used with max_string_size to "EXTENTED"
- [directories] Remove the correct passwordfile
- [ora_exec] Recognise the a sensitive statement in notice on refresh

## 3.11.3

- [ora_listener] Add instance_name parameter
- [ora_user] Fix idempotency issue on password when user is SYS in Oracle 12 and higher
- [ora_awr_settings] Fix index on pluggables and RAC instances

## 3.11.2

- [ora_schema_definition] Fix second pass on database with empty connection_string in ora_settings (#194)

## 3.11.1

- [release] Fix stdlib dependency metadata 

## 3.11.0

- [core] Fix undefined method error in rare cases
- [ora_home_option] Add Unified Auditing option
- [ora_awr_settings] Fix documentation bug (#189)
- [ora_autotask] Add custom type to manage autotasks
- [core] Set pause off
- [ora_database] Handle archivelog and flashback properties as group

## 3.10.0

- [release] Add support for RedHat 8 and remove support for RHEL 4 and 5
- [ora_database] Add flashback property (#185)
- [ora_awr_settings] Add ora_awr_settings custom type (#184)
- [ora_listener] Fix puppet resource methods

## 3.9.10

- [core] Fix default sid detection for Oracle RAC databases

## 3.9.9

- [release] Add free trial banner to README

## 3.9.8

- [ora_user] Fix data type of create_only
- [ora_user] Fix error handling on quota
- [ora_user] Fix error handling when integer value is passed to grants field
- [ora_record] Fix data type issues
- [ora_asm_volume] Allow flexible sizes and fix idempotency
- [ora_asm_diskgroup] Handle dismounted diskgroup state (#182)
- [settings] Empty connect_string implies local
- [ora_init_param] Fix idempotency when for_sid is equal to sid on SPFILE param
- [ora_database] Make autostart better idempotent
- [ora_init_param] Fix support for setting memory parameters for a different sid
- [mungers] Resource api excludes upcase munger
- [ora_service] Properly set the db and sid when calling srvctl
- [ora_init_param] No more checks on for_sid parameter when scope is memory
- [core] Handle invalid UTF8 characters in the sql output

## 3.9.7

- [ora_service] Lookup container for pdb's, take undef value into account and conditionally stop service

## 3.9.6

- [ora_service] Handle preferred_instances and available_instances as group
- [settings] Container database is also a 'normal' database

## 3.9.5

- [ora_scheduler_job] Fix when repeat_interval contains values with comma’s
- [ora_database] Bring spfile parameter in line with where we create the spfile
- [ora_tab] Conditionally add newline

## 3.9.4

- [ora_tablespace] Workaround for Puppet issue with external types
- [tasks::tablespace] Add support for new bolt version
- [tasks::sql] Add support for new bolt version
- [tasks::user] Add support for new bolt version
- [tasks::service] Add support for new bolt version
- [tasks::role] Add support for new bolt version
- [tasks::profile] Add support for new bolt version
- [information] Bring in line with facts (v$pdbs doesn't contain rootdb anymore in 19c)
- [ora_service] TAF failover delay and retries renamed in 19c
- [ora_service] status fix symbol compare + case insensitive search
- [ora_service] preferred_instances fix data_type
- [ora_database] catbundleapply doesn't exist anymore in 19c
- [ora_database] Run datapatch on container databases
- [ora_database] Cannot expire password on externally identified users
- [core] Use NLS_LANG=english  to always use english
- [ora_object_grant] Fix ora_object_grant.permissions expects a String value, error
- [ora_exec] Fix data type for mark_as_error
- [core] unset TWO_TASK added (#170)

## 3.9.3

- [core] Fix when using NLS support for non-english language
- [ora_asm_diskgroup] Remove data_type since VALIDATION will handle it
- [ora_database] No more default for oracle_home

## 3.9.2

- [ora_database] Fix issue with switching logfiles in RAC environment

## 3.9.1

- [ora_asm_diskgroup] Less strict types for compat_* properties
- [ora_database] Remove global oracle_home method
- [ora_database] Fix pdb connect string generation when no domain specified
- [ora_database] Fix when database longer then 10 characters
- [ora_database] Fix data types for passwords
- [ora_database] Don’t use data type for sysaux_datafiles parameter
- [ora_database] Don’t use data type for datafiles parameter
- [ora_exec] revert the refresh message from debug to notice
- [core] Add compatible data type checks on older Puppet versions

## 3.9.0

- [ora_exec] Change refresh notice into debug message
- [ora_service] Change warning into debug message on non clustered services
- [core] Specify REAL data types for all properties and parameters
- [ora_database] Fix bug in logfile_groups

## 3.8.1

- [core] Don’t connect to pluggable when container not up
- [ora_database] Make contained_by a property
- [ora_database] Don’t fetch logfile_groups when database is down
- [ora_database] Make state better idempotent
- [ora_database] make autostart better idempotent
- [ora_database] Fix occasional Ora_setting redefine
- [ora_database] Don’t make a oratab entry for.a pluggable database

## 3.8.0

- [ora_database] Add overwrite parameter and check
- [core] Fix when ora_settings file is empty.
- [ora_user] quotas ignore dropped tablespaces

## 3.7.0

- [core] Add Windows support
- [ora_database] Fix logfile_groups when used with Puppet 6 and resource_api loaded

## 3.6.4

- [ora_settings] Fix manageing default instances

## 3.6.3

- [ora_user] Fix password creation when no current salt is available

## 3.6.2

- [ora_user] Fix type compare on crreate_only properties
- [core] Add support for Oracle 19 password hashing

## 3.6.1

- [ora_exec/ora_tablespace] Change info to debug messages
- [ora_database] Fix force_logging property with Puppet 6

## 3.6.0

- [ora_database] Fix idempotency on acrhivelog property on puppet 6 and higher
- [core] Add Oracle 19 support

## 3.5.3

- [ora_service] Correctly identify pluggable databases. 

## 3.5.2

- [core] cotainer support is backwards compatible with Oracle 12.1 and Oracle 11
- [core] Add support for Regexp styrings in versioned queries

## 3.5.1

- [ora_job_scheduler] No default value for start_date property
- [ora_job_scheduler] Fix idempotency on enabled property

## 3.5.0

- [facts] Confine the ora_version fact to running Oracle database
- [ora_user] Add check for double values in common_granted_with_admin
- [core] Fix puppet6 compatibility issues
- [ora_object_grant] Fix wildcard permissions on container database
- [ora_schema_definition] Fix when running in container database
- [core] Fix symbol comparison
- [ora_object_grant] Fix container permissions
- [ora_object_grant] Fix updating with_grant_permission
- [ora_object_grant] Fix error in container processing
- [ora_role] Add support for container common grants
- [ora_user] Add support for container common grants
- [core] Add support for container common grants
- [ora_object_grant] Fix persmissions when used with container databases
- [ora_profile] Fix container property
- [ora_user] Fix container property

## 3.4.0

- [ora_user] Add support for raw_password property
- [core] Only fetch pluggable status when we are a container db
- [ora_service] Add support for services on pluggable databases
- [settings] Fix detection of pluggable databases
- [ora_service] Add support for plugable database services on cluster

## 3.3.2

- [core] unset TNS_ADMIN variable
- [ora_object_grant] Fix container property

## 3.3.1

- [ora_init_param] Fix data type issues
- [core] Allow pluggable databases without extra licence

## 3.3.0

- [core] Reintroduce the sqlplus daemon to decrease load on server
- [ora_init_param] Puppet version dependent value resources
- [ora_database] Report database name when using RAC
- [core] Allow pluggable databases without extra licence

## 3.2.5

- [ora_database] add format for name column
- [ora_database] Add datapatch to creation

## 3.2.4

- [information] database is falsely identified as being OMF enabled

## 3.2.3

- [ora_tablespace] Fix symbol issue
- [ora_tablespace] Multiple fixes string versus symbols compare
- [ora_init_param] Determine data type of the value
- [ora_database] handle situation where db_name differs from SID

## 3.2.2

- [ora_service] Fix mechnism for getting defaullt value for status

## 3.2.1

- ora_service] Fix invalid command when unkown instances are found  #149
- [ora_service] Add support for managing status on standby modes

## 3.2.0

- [core] Skip windows systems until Windows support is adequate
- [functions] Add helper function to determine if instance is a RAC cluster
- [facts] Add ora_is_cluster fact to signal if node is RAC cluster node

## 3.1.0

- [ora_function] Initial implementation
- [ora_user] Signal error when any of the grants or revoke properies contains double values

## 3.0.2

- [ora_user] Fix small bug in quotas and add qcceptance tests
- [ora_user] Case insensitive compare of unlimited quotas value
- [ora_service] Fix state property
- [core] Add initial support for running on windows
- [core] Make settings file location different for windows

## 3.0.1

- [listener] Fix issue caused by using undefined Oracle home
- [acceptance] Start using Puppet 6 for automated acceptance
- [core] Use puppet 6 in development container

## 3.0.0

- [core] Add support for Puppet 6
- [core] Add unittests for Puppet6
- [core] Update summary text to include Oracle versions
- [ora_service] Fix bug where the services of all databases are created in each database when having multiple databases in one system
## 2.10.1

- [core] Fetch database role also on older Oracle versions
- [ora_exec] Fix report_errors behaviour

## 2.10.0

- [ora_schema_definition] Fixed empty up and downgrade & downgrades in general
- [ora_schema_defintion] Added acceptance tests
- [ora_trigger] Fix typo in to_get_raw_resources
- [core] Add support for standby databases
- [core] Use version from v$instance
- [ora_statement_audit] Fix documentation

## 2.9.0

- [core] Add support for Oracle 18 password hashes
- [ora_tablespace] Add Oracle18 support
- [ora_profile] Add Oracle18 support
- [ora_object_grant] Add Oracle 18 support

## 2.8.0

- [release] Update the README
- [feature] Add Oracle 18c to oracle12 provider

## 2.7.0

- [functions] Added easy functions for checking certain facts


## 2.6.8

- [core] Fix selection of default sid when used with ora_database creation

## 2.6.7

- [ora_database] Use the specfied oracle os_user for database creation
- [ora_service] Add 12.2 properties for Application Continuity/Transaction Guard
- [ora_service] Only skip unknown instances

## 2.6.6

- [ora_service] Change warning to info. Closes #139
- [ora_tablespace] Fix ignored unlimited max_size setting. Closes #138

## 2.6.5

- [core] Make support for Suse more explicit

## 2.6.4

- [ora_service] Fix missing -preferred option in srvctl cluster command on initial run
- [core] Don’t cache ora_settings information
- [core] Add debug messages to feature resolution
- [ora_object_grants] Fix issue on wildcard matching Oracle 11
- [ora_object_grant] guard against messages without called insync?
- [ora_scheduler_job] Add documentation

## 2.6.3

- [core] Fix error’s in detecting running Oracle

## 2.6.2

- [facts] Fix ASM running detection
- [ora_object_grant] Check syntax of object_name

## 2.6.1

- [core] Fix bug when fetching empty ora_init parameter

## 2.6.0

- [ora_object_grant] Implement wildcard objectgrant for new grants
- [core] Use egrep for finding processes
- [core] Added some more debugging
- [core] Add AIX support
- [ora_object_grant] Add support for wildcard tables
- [core] Moved support for multiple versions of  aquery doen to the lowest level
- [core] Optimize memory usage and speed by using trimspool

## 2.5.2

- [ora_object_grant] Fixed performance
- [ora_service] Fix incorrect command and other bugfixes. Closes #126
- [ora_scheduler_job] bugfixes in on_create and templates

## 2.5.1

- [ora_user] Fix error when current password field in the database is NULL

## 2.5.0

- [core] loossen requirements for easy_type version
- [ora_scheduler_job] New type initial commit
- [ora_procedure] New type

## 2.3.24

- [core] Add longchuncksize value to all SQL executes
- [test] Update tested Puppet versions

## 2.3.23

- [core] Fix executing statements without parse
- [ora_record] Fix invalid invalid multibyte char
- [core] Add support for remote access
- Don't remove everything when there is a cluster error

## 2.3.22

- [tasks] Update the sql task to use more standard pattern for ruby loading
- [tasks] Update user task
- [tasks] Add tablespace task
- [tasks] Add service task
- [role] Add role task
- [tasks] Add profile task
- [develop] copy lib files to cache
- [core] Cleanup some old files

## 2.3.21

- [tasks] Remove task folder from the ignore list

## 2.3.20

- [tasks] Add taks sql and user
- [core] Add support for sql with no processing of the output
- [ora_database] Remove ruby 1.8.7 fix.
- [ora_database] Make check to add instance more specfic

## 2.3.19

- [ora_exec] Fix operation when using refreshonly

## 2.3.18

- [ora_exec] Fix when refreshonly is set to true
- [release] Fix link to license i readme
- [release] Fix module name in license text

## 2.3.17

- [release] Update License text
## 2.3.16

- [release] Add license text and commercial license text

## 2.3.16

- [core] Fix textual typo in many sources
- [ora_exec] Add onlyif parameter
- [ora_user] Set a better default password
- [docs] Update docs

## 2.3.15

- [README] Updated for publishing on the forge
- [ora_database] [core] Fix incompatibility with ruby 1.8.7
- [core] Fix incompatibility with ruby 1.8.7

## 2.3.14
- [core] Fix detection of root database
- [ora_service] Persist services_names on regular databases
## 2.3.13
- [ora_database] Fix undefined Puppet::Type::Ora_setting

## 2.3.12
- [ora_database] Fix 'Attempt to redefine entity error'

## 2.3.11
- [ora_service] Fix warning "preferred_instances has no effect..."
- [ora_database] Only add instance for local node
- [ora_database] Manage properties for RAC databases
- [schemas] Handle Integer. Closes #116

## 27-07-2017 Version 2.3.10
- [core] Update easy_type dependency

## 27-07-2017 Version 2.3.9
- [ora_database] Fix logfile_groups when database does not (yet) runs.
- [ora_service] Add support for removing instanced from running service
- [ora_database] Set privileges on dbca directory correctly. Closes #113
- [ora_service] Fix default value that breaks first run
- [ora_tablespace] Fix validation that breaks first run
- [ora_database] Manage redologs
- [ora_service] Fix unit tests

## 14-06-2017 Version 2.3.8
- [ora_service] Make available instances default for preferred_instances
- [ora_tablespace] treat datafiles property like a parameter when OMF enabled
- [asm_facts] Only run these facts on a Linux system
- [ora_service[ Better error message on starting
- [ora_service] Fix changing preferred_instances

### 10-05-2017 Version 2.3.7
- [ora_database] manage state of database
- [ora_tablespace] Convert the other way as well for max_size unlimited
- [ora_tablespace] Fix puppet resource issue. Closes #106
- Fix bigfile issue and don't allow removing datafiles

### 21-04-2017 Version 2.3.6
- [ora_database] Fix error when using force_logging
- [ora_tablespace] Fix bugs and add spec tests
- [ora_tablespace] remove byebug gem
- [ora_tablespace] Add separate queries to index query
- [ora_feature_usage] show all features
- [ora_tablespace] Add support for multiple datafiles

### 10-03-2017 Version 2.3.5
- [ora_tablespace] Fix ruby 1.8.7 issue on encrypted tablespaces
- [core] Use timeout value specified
- [ora_service] Fix the check for db_domain when no dabase yet
- [ora_service] Fix spec
- [ora_service] Allow simple names when db_domain not set
- [ora_home_option] Add pathname for puppet server
- [ora_feature_usage] Add pathname for puppet server

### 10-03-2017 Version 2.3.4
- [ora_tablespace] Add support for encrypted tablespaces
- [ora_database] Don't remove directories when pluggable database creaetion fails Closes #97
- [ora_user] Fix double identified by issue. Closes #90
- [ora_database] Add default value for temporary_tablespace in template
- [ora_user] Fix bug related to current_hashed_password
- [ora_feature_usage] Add where clause
- [ora_feature_usage] Remove where condition and cleanup
- [ora_feature_usage] Add type
- [ora_home_option] Remove debug statements

### 28-02-2017 Version 2.3.3
- [ora_database] sqlplus variable sysPassword and systemPassword only set for container databases. Closes #96

### 28-02-2017 Version 2.3.2
- [core] Fix name clash on Hash
- [ora_home_options] Initial version
- [ora_trigger] Fix problems with triggers containing special characters
- [ora_init_param] Extract the hex_to_raw function from ora_init_param
- [ora_setting] Ensure correct loading on PE

### 08-02-2017 Version 2.3.1
- [ora_service] Fix Oracle12 provider
- [ora_tablespace] Fix unit tests
- [ora_profile] Fix spec
- [ora_tablespace] Fix next property
- [ora_asm_diskgroup] Fix properties
- [ora_asm_directory]  Fix used sid parameter

### 30-01-2017 Version 2.3.0
- [ora_role] Add container property
- [ora_service] Add confinement to have Oracle running
- [ora_database] Always uppercase database names
- [ora_user] autorequire tablespaces in quotas
- [ora_user] Allow container based profiles
- [ora_profile] Allow container based profiles
- [core] Allow container based grants
- [core] Allow passwordless connect to normal and containers
- [ora_service] Remove default value for preferred_instances
- [ora_service] Add support for services in pluggable database
- [ora_service] Service name must be a full qualified name
- [ora_service] Only provide default for preferred_instances when cluster
- [facts] Make ASM facts compatible with older puppet versions
- [ora_database] Create oratab entry for pdb
- [ora_database] Fix connect string for pdb
- [ora_service] Make properties case-insensitive
- [core] Better handling of default sids for all database types
- [ora_database] Handle cluster databases
- [core] include path in all informational and warning messages
- [ora_database] Fix setting the default when only one database is present
- [ora_database] Fix archiving detection. And fix settings name when cluster
- [ora_service] Make casing of properties less strict
- [ora_service] Make it work in first run when Oracle will be installed
- [core] include resource name in warnings and info messages
- [ora_database] Allow modification of archive mode
- [ora_setting] Reset default on other entries when new default added
- [ora_database] Compatible for Oracle 11
- [core] Make grant_property ruby 1.8.7 compatible
- [core] Make settings ruby 1.8.7. compatible
- [information] Make information block Oracle 11 compatible
- [core] No permissions on /root for os_user
- [facts] Fix is_container_db fact
- [facts] Don’t allow the facts to import information into Object
- [ora_object_grant] Add container scope to sql statement
- [core] Use container only on Oracle12 versions
- [core] Fix containerdb information
- [ora_object_grant] Add container property
- [ora_profile] Used versioned statement for to_get_raw_resources
- [ora_user] Add the container property
- [ora_profile] Add support for container property
- [facts] Add plugable db facts
- [ora_database] Silently ignore archivelog, autostart and force_logging for pluggable databases
- [ora_database] Fix several issues with pluggable databases
- [facts] Add  support for array and record facts. Also add support for asm, and mgmt facts
- [parser] Add functions generated_password and available_sids
- [ora_init_param] fix default for_sid implementation
- [ora_init_param] Fix default for_sid when SPFILE parameter
- [core] Add support for setting the os_user in the ora_settings
- [ora_init_param] Start using the new map_titles_to_attributes
- [core] Start using the new map_titles_to_attributes
- [providers] confine to work only when ora_settings.yaml is present
- [ora_asm_directory] Fix typo
- [core] Better error reporting when an error occurs in a command. Closes #76
- [core] No default for username
- [ora_role] Allow updates of roles
- [ora_object_grant] Fix typo in the documentation
- [ora_user] Better password generation
- [ora_settings] Display message after generate
- [core] Fix output logging in relation with error handling
- [ora_database] Remove sid as parameter
- [core] MAke adm_sid and sid namevars
- [ora_object_audit] Initial implementation
- [ora_statement_audit] Added intial implementation
- [ora_user] Remove default for profile
- [core] Fix issue when password is empty
- [ora_settings] Implement conversion utility
- [core] Implement output logging. Closes #87
- [ora_database] Generate random passwords and don't fail if they are not specified
- [ora_service] Fix creation of non-clustered service
- [ora_database] Make force logging manageable
- [ora_database] Make autostart manageable
- [ora_database] Call the perl from the ORACLE_HOME
- [ora_database] Added options parameter
- [ora_database] Made container database creation
- [ora_database] Add support for pluggable databases initial commit
- [ora_database] Fix file_name_convert in template
- [ora_database] Move to simple provider
- [ora_database] Manage ora_settings entry on create and destroy
- [ora_database] Fix logging for destroy operations
- [core] Fix database running detection
- [core] Fix variable expansion in sql command
- [ora_setting] Use the easy_type yaml_type as implementation.
- [ora_database] Create container database initial commit
- [core] Add default property and remove oracle_sid property
- [ora_database] Make ora_database manageable
- [core] Remove all references to oratab which moved to ora_setting or were not needed anymore
- [core] Refactor access to settings
- [core] Removed sysdba and added syspriv property to ora_setting and other stuff
- [ora_databae] Add pluggable property, true boolean properties and don't fail on invalid sid(for remote connections
- [ora_setttings] Initial implementation
- [ora_object_grant] Add support for grants with grant option
- [ora_role] Added support for grants_with_admin, granted_with_admin and revoked_with_admin
- [ora_user] Added support for grants_with_admin, granted_with_admin and revoked_with_admin
- [core] Added support for with_admin grants
- [ora_role] Added granted and revoked property
- [ora_user] Added granted and revoked property
- [ora_user] Added property revoked and granted
- [ora_service] Port to new easy_type
- [facts] Allow all sorts of structures facts
- [ora_service] Also include the last service
- [core] Remove some leftovers from command_builder
- [ora_asm_volume]  use new easy_type features
- [ora_asm_diskgroup]  use new easy_type features
- [ora_database]   use new easy_type features
- [ora_trigger] use new easy_type features
- [ora_thread] use new easy_type features
- [ora_synonym] use new easy_type features
- [ora_service] use new easy_type features
- [ora_schema_definition]  use new easy_type features
- [ora_record]  use new easy_type features
- [ora_profile]  use new easy_type features
- [ora_package]  use new easy_type features
- [ora_object_grant] use new easy_type features
- [ora_directory] use new easy_type features
- [ora_init_param]  use new easy_type features
- [ora_role]  use new easy_type features
- [ora_asm_disk] Fix handling of unsorted entries
- [ora_asm_disk] Fix handling of unsorted entries
- [ora_tablespace] use new easy_type features
- [ora_service] Set default value to running
- [ora_service] Make the current instances the default for preferred_instances
- [ora_database] Add support for report_errors parameter
- [ora_service] Use features to decide on provider
- [core] Add Oracle11 and Oracle 12 features
- [ora_asm_volume] Fix usage of asm_sid
- [ora_asm_diskgroup] Fix usage of asm_sid
- [ora_service] Implementation of all cluster properties
- [ora_service] index shows all cluster properties
- [ora_service] Add support for all srvmgr properties
- [ora_service] Fix issue in detecting partly stopped services
- [ora_profile] Support K/M etc on private_sga property. Closes #74
- [ora_profile] Fix casing problem. Closes #75
- [ora_service] Add support for running property
- [ora_asm_diskgroup] Fix issue in ordering of disk_group
- [ora_exec] Trigger refresh always when no unless is specified
- [core] use base sid for determining autorequires
- [ora_init_param] Fix parameters with values containing , and other exotic characters
- [core] remove bare named elements on autorequire when sid is set
- [ora_trigger] Fix autorequire
- [ora_package] Fix autorequires
- [ora_trigger] Fix autorequires
- [ora_record] Fix autorequires
- [ora_schema_definition] Fix autorequires
- [ora_synonym] Fix autorequires
- [ora_object_grant] Fix autorequires
- [ora_exec] Fix autorequires
- [ora_user] Fix autorequires
- [core] Added ora_autorequire function for compex autorequires
- [ora_record] Fix documentation
- [ora_exec] Fixed respecting the unless parameter on refresh
- [ora_asm_diskgroup] Fix when removing multiple diskgroups
- [ora_asm_diskgroup] Fix when adding multiple diskgroups
- [ora_tablespace] Add support for resizing smallfile tablespaces
- [ora_asm_diskgroup] Fix multiple issues
- [ora_asm_disk] Add acceptance tests
- [core] Make vagrant development bxo same as acceptance test box
- [ora_user] Better implementation of the default_roles property
- [ora_user] Fix ordering issue on default_roles property
- [ora_user] Improved handling of default roles value ALL and NONE
- [ora_sql_schema_definition] Fix error because of non existing directory
- [core] Move validation of sid down in stack
- [ora_schema_definition] Add support for remote files in source_path
- [ora_asm_diskgroup] Fix ruby 1.8.7 problem
- [ora_schema_version] Add better documentation
- [ora_schema_definition] Add default empty value for parameters
- [ora_schema_definition] Better error message when file name syntax in incorrect.
- [ora_record] Add autorequire for user
- [ora_package] Add autorequire for user
- [ora_exec] Add autorequire for user
- [ora_database] Fixed problems in logfile_groups
- [ora_user] Fix missing quote in docs
- [ora_asm_diskgroup] Add update support

### 12-09-2016 Version 2.2.7
- [ora_database] Support Oracle Managed Files for log file groups

### 08-09-2016 Version 2.2.6
- [ora_database] Fix multifile fixed number log groups
- [docs] Update docs

### 07-09-2016 Version 2.2.5
- [ora_database] Add support for multiple log files per loggroup
- [ora_trigger] Add support for (non)editionable create scripts
- [ora_package] Add support for (non)editionable create scripts

### 26-08-2016 Version 2.2.4
- [ora_init_param] Update content quoting to latest version of easy_type
- [ora_exec] Add support for mark_as_error parameter,
- [ora_package] Add difference reporting on source
- [ora_package] Update the documentation
- [ora_trigger] Initial implementation

### 20-08-2016 Version 2.2.3
- [ora_init_param] Handle quites in the values
- [ora_package] Fix provider name
- [core] Add support to manage mgnt database
- [core] Fix all usage of template function
- [ora_package] Implemented error checking and updated the documentation
- [core] Add support for catching additional errors
- [ora_package] Use refactered sql routine with raw access
- [ora_package] Initial implementation
- [ora_schema_definition] Implement empty instances method
- [facts] Add generic setup for making your own facts
- [core] set all files modes to correct values
- [core[ Handle -MGMTDB database
- [docs] Added documetation for using non-standard os users

### 13-07-2016 Version 2.2.2
- [core] Add correct geppetto  project file
- [ora_object_grant] Fix autorequire in ora_object_grant
- [core] Add geppetto  project file
- [ora_tablespace] Fix managing properties of temporary tablespaces
- [ora_object_grant] If object name has a user, autorequire it
- [ora_object_grant] Add autorequire to grantee
- [ora_user] Fix error when quota is empty
- [ora_user] Fix error in multiple properties when just one change
- [ora_object_grant] Use a prefetching provider to spare memory

### 29-06-2016 Version 2.2.1
- [ora_user] Fix error when only grants change

### 28-06-2016 Version 2.2.0
- [core] Better checking on db sid
- [core] moved all shared properties to named directory
- [ora_asm_volume] Fix the index operation
- [ora_asm_disk_group] Fix index operation
- [ora_schema_definition] Fix error in creation sql
- [core] Load profile but reset path to wd of parent proces
- [ora_user] Fix when default_roles and grants are specified
- [ora_user] Add properties locked & expired
- [core] Don't load profile for oracle commands
- [core] Better error reporting on all sql
- [ora_synonym] Replace simple provider by prefetching one
- [ora_instance] Initial implementation
- [ora_synonym] First implementation
- [ora_directory] Initial implementation


### 26-05-2016  Version 2.1.0
- [ora_asm_diskgroup] Make sure the disks are in sync
- [ora_init_param] Fix when running in a RAC cluster
- [ora_user] fix default_roles property
- [ora_user] Make profile an uppercase property
- [ora_user] Remove user_id
- [core] Remove temporary files after we have used it.
- [ora_user] Add support for default_roles
- [ora_tablespace] Make size updates work with Oracle Managed Files
- [ora_user] Fix Puppet deprecation warning
- [ora_role] Fix Puppet deprecation warning
- [ora_profile] Fix Puppet deprecation warning
- [ora_object_grant] Fix Puppet deprecation warning
- [ora_init_param] Fix Puppet deprecation warning
- [ora_exec] Fix Puppet deprecation warning
- [ora_tablespace] Fix usage of oracle named files
- [ora_profile] Add new type to manage Oracle user profiles
- [ora_user] Added profile property
- [ora_schema_definition] Fix downgrade paths
- [ora_asm_diskgroup] Remove empty lines in create statement
- [ora_tablespace] Fix typo in help text
- [ora_asm_diskgroup] Use the au_size propery on creating the diskgroup
- [ora_user] Fix issue with default password
- [core] Adhere to puppetlabs guidelines for libraries
- [ora_user] Generate a radnom password for a user when password is not specified
- [core] Update used gems
- [core] Fix security issues with world readable files
- [ora_user] Make password a manageble property
- [ora_object_grants] Change resource name and added default permissions
- [ora_object_grant] Fix possible error on insync?. Closes #72
- [ora_object_permissions] Fix case sensitivity for permissions. Closes #71
- [ORA_RECORD] Updated documentation
- Improved documentation for several types
- [ORA_OBJECT_GRANT] renamed the type ora_object_permission to ora_object_grant
- [ORA_INIT_PARAM] Fix error in idempotence when value is a real number
- Some generic fixes
- Add support for modified_only acceptance tests
- [ORA_USER] Added checks for object_rights
- Removed the check for old sid syntax.
- [ORA_OBJECT_PERMISSION] Added type to  manage object permissions
- [ORA_EXEC] Add support for ignoring SQLPlus errors
- Add better documentation
- Move acceptance tests over to Oracle 12C
- Update travis for Puppet 4.2.3
- Fix test versions
- [ORA_DATABASE] Fix test manifest
- ORA_TABLESPACE] Fix creation of temporary tablespaces
- [ORA_INIT_PARAM] Quote the parameter name
- [ORA_TABLESPACE]Fix autoextending and changing size
- Acceptance tests running in enterprisemodules context
- Add identity files
- Update of the Gems. This allows us to run rake acceptance again
- [ORA_TABLESPACE] Add support fot specifying block_size

### 30-10-2015  version 2.0.0.0
---------------------------
- Renamed to ora_config

### 27-10-2015  version 1.7.22
--------------------------
- Fix when using ora_init_param on multiple instances

### 27-10-2015  version 1.7.21
--------------------------
- Fix when using ora_init_param when one of the instances is a ASM instance

### 26-10-2015  version 1.7.20
--------------------------
- Fix when using ora_init_param on a node with multiple databases
- Fix when using ora_init_param without a specified database.

### 26-08-2015  version 1.7.19
--------------------------
- timeout parameter was not honoured. Now fixed

### 26-08-2015  version 1.7.18
--------------------------
- Fix undefined method sort for ora_init_param

### 25-08-2015  version 1.7.17
--------------------------
- Fix null quota's for ora_user.
- Fix idempotence for autoextend and maxsize

### 10-08-2015  version 1.7.16
--------------------------
- Added support for multiple values in ota_init_parameter

### 10-08-2015  version 1.7.15
--------------------------
- Allow letters in versionnumber of ora_racord upgrade and downgrade scripts

### 16-07-2015  version 1.7.14
--------------------------
- Set ownership for some more directories when creating a database

### 06-07-2015  version 1.7.13
--------------------------
- refreshonly on ora_exec now only logs a message when something is done.

### 06-07-2015  version 1.7.12
--------------------------
- Fix dropping triggers when reinstalling schema

### 01-07-2015  version 1.7.11
--------------------------
- Use instance name instead of database name for orapwd name.

### 19-06-2015  version 1.7.10
--------------------------
- only use lb_advisory on RAC clusters

### 17-06-2015  version 1.7.9
--------------------------
- added lb_advisory property to ora_service

### 17-06-2015  version 1.7.8
--------------------------
- Added refreshonly for ora_exec
- Check if the cwd specified for ora_exec is valid

### 09-06-2015  version 1.7.7
--------------------------
- Add support for timezone parameter on Ora_database

### 04-06-2015  version 1.7.6
--------------------------
- Small fixes in ora_schema_definition

### 02-06-2015  version 1.7.5
--------------------------
- Better cleanup of schema_definition
### - Translate latest version to real number

### 02-06-2015  version 1.7.4
--------------------------
- Better logging of script that are running
- Ignore characters in versions of upgrade and downgrade scripts


### 27-05-2015  version 1.7.3
--------------------------
- Small fix for ora_schema_defintion removing occasional error's

### 22-05-2015  version 1.7.2
--------------------------
- Better error checking on data attribute of ora_schema_defintion


### 21-05-2015  version 1.7.1
--------------------------
- Small fixes to ora_schema_definition and ora_record.

### 20-05-2015  version 1.7.0
--------------------------
- Added ora_schema_definition type. This type helps in managing the table defintions of your applications
- Added ora_record. This type supports manageing configuration records in database

### 13-05-2015  version 1.6.6
--------------------------
- Fixed creating a tablespace when no datafile is specified

### 24-04-2015  version 1.6.5
--------------------------
- Fixed changing tablespaces
- Added support for Puppet 4

### 08-04-2015  version 1.6.4
--------------------------
- Now realy works on RAC...

### 04-04-2015  version 1.6.3
--------------------------
- ora_service now works on RAC systems
- ora_service noew presists the services on non RAC systems


### 23-03-2015  version 1.6.2
--------------------------
- Quick bugfix

### 23-03-2015  version 1.6.1
--------------------------
- Small fix for `ora_exec` when `unless` is specified without a username


### 23-03-2015  version 1.6.0
--------------------------
- Removed the oracle daemon. Totaly. This makes the code easier to read.
- some small changes in `ora_database` for RAC support.
- improved error handling of sql code. This may lead to error's not seen before.
- Support for multiple disks in ora_asm_diskgroups.

### 04-03-2015  version 1.5.4
--------------------------
- Fixed spfile creation on RAC nodes
- Made direct sql the default for sql commands. This is the first step in removing the daemon.

### 07-02-2015  version 1.5.3
--------------------------
- Allow `ora_init_param` to manage ASM instances

### 03-02-2015  version 1.5.2
--------------------------
- Added the `unless` parameter to `ora_exec`

### 30-01-2015  version 1.5.1
--------------------------
- ora_tablespace max_size property now supports value unlimited

### 29-01-2015  version 1.5.0
--------------------------
- Support for asm_volumes
- Added a fact to get asm volume information (With help from Corey Osman)
- Fixed ora_asm_diskgroup attribute au_size


### 19-01-2015  version 1.4.0
--------------------------
- Add grant privileges function to ora_role (Thanks to Edward Groenenberg)
- Now works on Oracle XE (Thanks to Andreas Wegmann)
- ora_database can now remove clustered databases

### 12-01-2015  version 1.3.0
--------------------------
- Re-enginered the ora_database
- make the fact use of os_user work for both Oracle and ASM

### 07-01-2015  version 1.2.0
--------------------------
- Added the initial implementation of ora_database
- Add functionality to use a fact to specify os_user for oracle and asm. Fixes #36


### 07-01-2015  version 1.1.0
--------------------------
- Cleaned up contents of distributed package
- autorequire the oracle users tablespace
- Some fixes and clarifications for ora_asm_diskgroup. BEWARE: The api has changed. Check the README for details.
- Added support for oratab on Solaris.


### 16-12-2014  version 1.0.0
--------------------------
- Fixed some bugs

### 27-11-2014  version 0.7.0
--------------------------
-Big API change. Change all type names to ora_..
- Have the sid at with @ at the back instead with a slach at the front. eg. it used to be SID/HAJEE. Now it is HAJEE@SID


### 27-11-2014  version 0.6.0
--------------------------
- init params now works with a different syntax for specifying the name. Check the readme for details
- Added support for 'growing' small file tablespaces. the type doesn't try to downscale a grown tablespace
- Added support for running under a different os_user.


### 07-10-2014  version 0.5.0
--------------------------
- Added custom type asm_diskgroup. This group supports creating and removing ASM disk groups.
Parts of it are writen by Remy van Berkum (remy.vanberkum@vermont24-7.com). Also added support
for connecting to the ASM instances with the sysasm user


### 24-09-2014  version 0.4.0
--------------------------
- Added some types needed for Oracle RAC


### 08-09-2014  version 0.3.1
--------------------------
- defaults SID's now work for all types.
- Changed documentation to show use with SID

### 08-09-2014  version 0.3.0
--------------------------
- Added support for multiple SID's.
- The listener now needs a sid as title. This is potential incompatible with previous versions where the name could be anything.
- Added support for specifying the SID for init_param

Before this, history not really recorded. Look at git history for details
