#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:auto_optimizer_stats_collection) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access

  desc <<-EOD
    The Optimizer Stats collection autotask

    ora_autotask { 'DBNAME':
      ...
      auto_optimizer_stats_collection => 'enabled',
      ...
    }

  EOD

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('AUTO_OPTIMIZER_STATS_COLLECT')
  end

  newvalues(:enabled, :disabled)
  data_type("Optional[Enum['enabled', 'disabled']]")

  on_modify do
    action = value == 'enabled' ? 'enable' : 'disable'
    statement = "exec dbms_auto_task_admin.#{action}(client_name => 'auto optimizer stats collection', operation => null, window_name => null)"
    sql(statement, :sid => local_sid_for_db(resource.name))
    nil
  end

end
