#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:auto_task) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access

  desc <<-EOD
    The SQL Tuning Advisor autotask

    ora_autotask { 'DBNAME':
      ...
      auto_task => 'enabled',
      ...
    }

  EOD

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('AUTO_TASK')
  end

  newvalues(:enabled, :disabled)
  data_type("Optional[Enum['enabled', 'disabled']]")

  on_modify do
    action = value == 'enabled' ? 'enable' : 'disable'
    statement = "exec dbms_auto_task_admin.#{action}"
    sql(statement, :sid => local_sid_for_db(resource.name))
    nil
  end

end
