#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:retention) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access

  desc <<-EOD
    The AWR retention in days.
  EOD

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('RETENTION')
  end

  data_type('Optional[Integer]')

  on_modify do
    statement = "exec dbms_workload_repository.modify_snapshot_settings(retention => 1440*#{value})"
    sql(statement, :sid => local_sid_for_db(resource.name))
    nil
  end

end
