#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:topnsql) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access

  desc <<-EOD
    The Top N number of statements to capture.
  EOD

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('TOPNSQL')
  end

  data_type("Optional[Variant[Integer, Enum['DEFAULT']]]")

  on_modify do
    statement = value == 'DEFAULT' ? "exec dbms_workload_repository.modify_snapshot_settings(topnsql => 'DEFAULT')" : "exec dbms_workload_repository.modify_snapshot_settings(topnsql => #{value})"
    sql(statement, :sid => local_sid_for_db(resource.name))
    nil
  end

end
