#
# See the file "LICENSE" for the full license governing this code.
#
# encoding: UTF-8
newproperty(:character_set, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access
  include Puppet_X::EnterpriseModules::Oracle::Information

  to_translate_to_resource do |raw_resource|
    if raw_resource['STATE'] == 'running'
      database_properties(raw_resource['SID']).find {|e| e['PROPERTY_NAME'] == 'NLS_CHARACTERSET' }['VALUE']
    else
      nil
    end
  end

  desc <<-EOD
    Specify the character set the database uses to store data.
  EOD

  data_type("Optional[String[1]]")
  on_apply do
    "character set #{value}"
  end
end
