#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:daemonized, :boolean => true, :parent => Puppet::Property::Boolean) do
  include EasyType

  desc <<-EOD
  Use daemonized sqlplus process for processing.

  By default Puppet will create a new sqlplus session for every set of information
  it needs to retrieve. This can put some strain on the Oracle database. When you
  want to decrease this, you can set the daemonized setting to true. This wil create
  a single daemon process for every database it needs to connect to and share
  this process for all sql processing.

  This is however more prone to instability. So use with care.

  The default value is `true` e.g. run sqlplus daemonized

      ora_database {'mydb'
        ...
        daemonized => true,
        ...
      }

  EOD

  data_type('Optional[Boolean]')

  defaultto :true
  newvalues(:true, :false)
end
  