#
# See the file "LICENSE" for the full license governing this code.
#
newparam(:default, :boolean => true, :parent => Puppet::Property::Boolean) do
  include EasyType

  desc <<-EOD
    When you set this value to true, this database will be used when no explcit `sid` is specified on the
    Oracle types.

    Many of the of the oracle types, allow you to NOT specfify the `sid` and use a default `sid`. This makes
    puppet manifests easier readable and less verbose when creating a manifest for a single database.

    The databasse for which you set the property `default` to `true`, is the database that will be used for those
    operations.

  EOD

  newvalues(:true, :false)

  data_type('Boolean')

end
