#
# See the file "LICENSE" for the full license governing this code.
#
# encoding: UTF-8
newproperty(:maxlogfiles, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include Puppet_X::EnterpriseModules::Oracle::Access
  include EasyType
  include EasyType::Validators::Integer

  desc <<-EOD
    define the limits for the redo log.
  EOD

  to_translate_to_resource do |raw_resource|
    if raw_resource['STATE'] == 'running'
      value = sql("SELECT RECORDS_TOTAL FROM v$controlfile_record_section where type = 'REDO LOG'", :sid => raw_resource['SID'])
      value.first['RECORDS_TOTAL']
    else
      nil
    end
  end

  on_apply do
    "MAXLOGFILES #{value}"
  end

  data_type("Optional[Integer]")
end
