#
# See the file "LICENSE" for the full license governing this code.
#
# encoding: UTF-8
newproperty(:maxlogmembers, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include Puppet_X::EnterpriseModules::Oracle::Access
  include EasyType
  include EasyType::Validators::Integer

  desc <<-EOD
    The maximum number of members, or copies, for a redo log file group.
  EOD

  to_translate_to_resource do |raw_resource|
    if raw_resource['STATE'] == 'running'
      value = sql("SELECT x$kccdi.dimlm MAXLOGMEMBERS FROM sys.x$kccdi", :sid => raw_resource['SID'])
      value.first['RECORDS_TOTAL']
    else
      nil
    end
  end

  on_apply do
    "MAXLOGMEMBERS #{value}"
  end

  data_type("Optional[Integer]")
end
