#
# See the file "LICENSE" for the full license governing this code.
#
# encoding: UTF-8
newproperty(:national_character_set, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Access
  include Puppet_X::EnterpriseModules::Oracle::Information

  to_translate_to_resource do |raw_resource|
    if raw_resource['STATE'] == 'running'
      database_properties(raw_resource['SID']).find {|e| e['PROPERTY_NAME'] == 'NLS_NCHAR_CHARACTERSET' }['VALUE']
    else
      nil
    end
  end

  desc <<-EOD
    The national character set used to store data in columns.
  EOD
  
  on_apply do
    "NATIONAL CHARACTER SET #{value}"
  end

  data_type("Optional[String[1]]")
end
