#
# See the file "LICENSE" for the full license governing this code.
#
# encoding: UTF-8
newparam(:overwrite) do
  include EasyType

  defaultto 'false'

  desc <<-EOD
  Overwrite existing admin home yes or no.

  When this parameter is set to `true`, Puppet will (possibly) overwrite an existing admin home, 
  when it determines the database does not exist. To make sure no destructive things happen to
  existing databases, the default is `false`,  e.g. no overwrite.

  You can set this value to `true` when (for example for CI purposes), you need to recreate a
  database with the same name.

  When Puppet determines that it needs to create a new database, and the admin directory does exist,
  and `overwrite` is set to false, Puppet will throw an error and not create the database,

      Error: /u01/app/oracle/admin/DB1222 or other sid related directories already exists. Not overwriting.
      Error: /Stage[main]/Main/Ora_database[DB1222]/ensure: change from 'absent' to 'present' failed: /u01/app/oracle/admin/DB1222 or other sid related directories already exists. Not overwriting.
EOD

  newvalues(:true, :false)

  data_type 'Boolean'

end
