#
# See the file "LICENSE" for the full license governing this code.
#
# encoding: UTF-8
newproperty(:timezone, :parent => ::Puppet_X::EnterpriseModules::Oracle::ReadOnlyProperty) do
  include Puppet_X::EnterpriseModules::Oracle::Access
  include Puppet_X::EnterpriseModules::Oracle::Information
  include EasyType

  to_translate_to_resource do |raw_resource|
    if raw_resource['STATE'] == 'running'
      database_properties(raw_resource['SID']).find {|e| e['PROPERTY_NAME'] == 'DBTIMEZONE' }['VALUE']
    else
      nil
    end
  end

  data_type("Optional[String[1]]")
  desc <<-EOD
    Set the time zone of the database.
  EOD
end
