#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/oracle/mungers'

newparam(:function_name) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase
  include EasyType::Validators::Name

  desc <<-EOD
    The name of the PL/SQL function you want to manage. The function name is the second part of the
    title.

        ora_function { 'owner.function_name@sid':
          ...
        }

  EOD

  isnamevar

  data_type("String[1]")
end
