#
# See the file "LICENSE" for the full license governing this code.
#
require 'puppet_x/enterprisemodules/oracle/mungers'

newparam(:job_name) do
  include EasyType
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase
  include EasyType::Validators::Name

  desc <<-EOD
    The name of the dbms_scheduler job you want to manage. The job_name is the second part of the
    title.

        ora_scheduler_job { 'owner.job_name@sid':
          ...
        }

  EOD

  data_type("String[1]")

  isnamevar
end
