#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:stop_on_window_close) do
  include EasyType

  desc <<-EOD
    Indicates wether or not the job schould be dropped once completed. 

    Here is an example on how to use this:

        ora_scheduler_job{ 'me.my_job@sid':
          ...
          stop_on_window_close => 'TRUE',
          ...
        }

    Default value: 'FALSE'

  EOD

  defaultto 'FALSE'

  newvalues('TRUE', 'FALSE')
  data_type("Optional[Enum['TRUE', 'FALSE']]")

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('STOP_ON_WINDOW_CLOSE')
  end

end
