#
# See the file "LICENSE" for the full license governing this code.
#
newproperty(:default_tablespace) do
  include EasyType
  include EasyType::Validators::Name
  include Puppet_X::EnterpriseModules::Oracle::CreateOnly
  include Puppet_X::EnterpriseModules::Oracle::Mungers::Upcase

  desc <<-EOD
    The user's default tablespace.
  EOD

  data_type('Optional[String[1]]')

  to_translate_to_resource do |raw_resource|
    raw_resource.column_data('DEFAULT_TABLESPACE').upcase
  end

  on_apply do
    "default tablespace #{resource[:default_tablespace]}"
  end
end
