#
# See the file "LICENSE" for the full license governing this code.
#
#++--++
#--++--
plan ora_config::extract(
  TargetSpec $target,
  String[1]  $sid,
  String[1]  $oracle_home,
  String[1]  $output_file,
  String[1]  $os_user      = 'oracle',
  Boolean    $cdb          = false,
  Boolean    $pluggable    = false,
  String     $contained_by = '',
) {

  $result = run_task('ora_config::extract', $target,
    sid          => $sid,
    oracle_home  => $oracle_home,
    os_user      => $os_user,
    cdb          => $cdb,
    pluggable    => $pluggable,
    contained_by => $contained_by,
  )
  easy_type::write_yaml($output_file, $result.first.value['resources'])
  out::message("Write data to ${output_file}")
}
